proc show_table {} {

    global x

    set database x
    wm maxsize . 1000 1000
   
    if {[string compare [info commands $database] ""] == 0} {
	open_sdb x timmins/t1p.inv
    }
    
    puts "Displaying table..."
    puts "number of rows:    [$database info num_records]"
    puts "number of columns: [$database info num_items]"

    table .a -rows [expr [$database info num_records] + 1] -cols [expr [$database info num_output] + 1] -ysc { .sv set } -xscr {.sh set } -rowt 1 -colt 1 -var $database -roworigin -1 -colorigin -1 -maxwidth 300 -maxheight 300
    scrollbar .sv -comm { .a toprow } 
    scrollbar .sh -com  { .a leftcol } -orient horizontal
    pack .sh -side bottom -fill x
    pack .sv -side right -fill y
    pack .a -side left -fill both -expand on

    .a tag con Flash -bg red -fg white
    .a tag configure notSelect -bg darkgreen -fg white
    .a configure -procrowtag rowTagProc
    .a flash tag Flash
    .a flash mode on
    .a draw fast
 #   update

    refresh
}

proc rowTagProc record {
    if [x select status $record] {
	return {}
    } else {
	return "notSelect"
    }
}

proc open_sdb {dbname filename} {
    puts "Preparing to open database $dbname on file $filename..."
    sdb open $dbname $filename
    puts "number of rows:    [$dbname info num_records]"
    puts "number of columns: [$dbname info num_items]"
}

proc refresh {} {

    global x
    # update the column width (in case columns have been added or removed)
    .a configure -cols [expr [x info num_output] + 1]

    # Update the selection set
#    x select not
#    eval ".a tag rowtag {} [.a tag rowtag notSelect]"
#    set rows [x position [x select first]]
#    while {[x info current] != [x select last]} {
#	lappend rows [x position [x select next]]
#    }
#    eval ".a tag rowtag notSelect $rows"
#    x select not
}

proc advance {amount} {
    global x
    incr x(date) $amount
    refresh
}

# open up the dataset
open_sdb x timmins/t1.inv

# toggle unneeded variables so they are not displayed on the spreadsheet
x output off CODE_1 SITE_1 CODE_2 SITE_2 CODE_3 SITE_3 CODE_4 SITE_4 CODE_5 SITE_5 AGE_1 STKG_1 VOLUME_1 AGE_2 STKG_2 VOLUME_2 AGE_3 STKG_3 VOLUME_3 AGE_4 STKG_4 VOLUME_4 AGE_5 STKG_5 VOLUME_5 

# redefine the database
x define date {1994}
x allocate origin NUMERIC
x calculate {origin=atof(ORIGIN)}
x delete DATE
x delete ORIGIN
x delete AGE_CLASS
x define age {date-origin}
x define age_class {age?(<,20,"regen"):(<,50,"immature"):(<,100,"mature"):"overmature"}

# select a set
puts "selecting overmature black spruce"
x select and {CODE=="Sb" && age_class == "overmature"}

# display the table
show_table

# instructions
puts "type 'advance 5' to age the inventory"
