#
# Timmins Crown Management Unit - HSG file format
#

if {![info exists db] || ![info exists $db]} {
    puts "loading inventory file..."
    set db [sdb open x t1.inv]
}

#
# Modify some of the fields in the inventory file
#
# Convert the label field 'ORIGIN' into a numeric field 'origin'
# so that it can be used in a math expression.
#
$db allocate origin NUMBER
$db calculate {origin=atof(ORIGIN)}
$db delete ORIGIN

#
# Get rid of the label field 'DATE' and create a numeric constant field
#
$db delete DATE
$db define date {1994}

#
# 'age' is defined as the difference between date and origin.  Whenever
# 'date' is change then the value of 'age' will change also.
#
$db define age {date-origin}

#
# Create a new expression called 'age_class' that will dynamically
# reclassify 'age' into a label.
#
$db delete AGE_CLASS
$db define age_class {age?(<,0,"error"):(<,20,"0-19"):(<,40,"20-39"):(<,60,"40-59"):(<,80,"60-79"):(<,100,"80-99"):(<,120,"100-119"):(<,140,"120-139"):"140+"}

#
# Try changing the value of date to see the other fields update
# automatically:
#  $db calculate {date=2000}
#
# Examine records using the 'get' command:
#  $db get 1
#
# Determine field positions using the info command
#  $db info items
#